#pragma once
#include <assert.h>

template <class T>
struct Array2D
{
	Array2D(){data = 0; clear();}
	Array2D(const Array2D<T> &a){data = 0; copy(a);}
	~Array2D(){clear();}

	T *data;
	int data_size;
	int s[2]; // size

	void operator=(const Array2D<T> &a) {copy(a);}
	void copy(const Array2D<T> &a)
	{
		resize(a.s);
		for (int i = 0; i < data_size; i++)
			data[i] = a.data[i];
	}

	void resize(int w, int h)
	{
		clear();

		data_size = w*h;
		s[0] = w;
		s[1] = h;

		data = new T[data_size];
	}
	template <class S> void resize(S p) {resize(p[0], p[1]);}

	T &operator()(int x, int y)
	{
		return data[y*s[0] + x];
	}

	template <class S>
	T &operator[](S p)
	{
		return data[p[1]*s[0] + p[0]];
	}

	void clear()
	{
		delete[] data;
		data = 0;
		s[0] = s[1] = 0;
		data_size = 0;
	}
};
