#pragma once

template <class T>
struct ListNode
{
	ListNode(){next = 0;}
	ListNode(T &d){next = 0; data = d;}

	ListNode<T> *next;
	T data;
};

template <class T>
struct List
{
	List(){root = end = 0; s = 0; cur = 0; idx = 0;}

	ListNode<T> *root; // only thing really needed

	int s; // used to speed size queries
	ListNode<T> *end; // used to speed push operations
	int idx; ListNode<T> *cur; // cache previous access to speed operator[]

	T &operator[](int i)
	{
		if (idx > i)
		{
			cur = root;
			idx = 0;
		}

		while (cur && idx < i)
		{
			cur = cur->next;
			idx++;
		}

		return cur->data;
	}

	void push(T &d)
	{
		s++;
		if (root == 0)
			cur = root = end = new ListNode<T>(d);
		else
		{
			end->next = new ListNode<T>(d);
			end = end->next;
		}
	}

	// push a default constructed element (in case the element is heavy weight and should be constructed in place)
	void push()
	{
		s++;
		if (root == 0)
			cur = root = end = new ListNode<T>();
		else
		{
			end->next = new ListNode<T>();
			end = end->next;
		}
	}

	void clear()
	{
		cur = root;

		while (cur)
		{
			ListNode<T> *next = cur->next;
			delete cur;
			cur = next;
		}

		root = end = 0;
		idx = s = 0;
	}

	T &last()
	{
		return end->data;
	}
};
